TYPOS.Flow - Bug # 45463

Status: Resolved Priority: Should have
Author: Karsten Dambekalns Category: MVC - Routing
Created: 2013-02-13 Assigned To: Bastian Waidelich
Updated: 2013-03-20 Due date:

PHP Version:

Has patch: No

Complexity:

Affected Flow version: Git master

Subject: Routing includes object arguments even though it should not

Description

Given this route as the only active route:
name: 'foo’
uriPattern: 'foo(/{@action})’
defaults:
'‘@package': '"Acme.Demo’
'‘@controller': 'Foo'
'‘@action': 'index’

and a controller with this action:

e
* @param \Acme\Demo\Domain\Model\Foo $foo
* @param string $bar
*/
public function removeBarAction(Foo $foo, $bar) {}

The following all works fine and results in a link being built (foo is an object):
<f:link.action action="removeBar" arguments="{foo: foo}">
<f:link.action action="removeBar" arguments="{xyz: foo}">
<f:link.action action="removeBar" arguments="{foo: foo, bar: foo}">

But this does not work (bar is a string):

<f:link.action action="removeBar" arguments="{foo: foo, bar: bar}">
The following happens inside the router:
https://www.evernote.com/shard/s55/sh/f3c49923-52d3-463e-848c-d68af1dbb17b/0e0c1426437d6808ba8f129a752760b6/res/6d01d
ce-dae0-49f1-b42e-02f641c8832f/skitch.png
https://www.evernote.com/shard/s55/sh/77505b48-94fb-4f1e-8334-7e6d8ac32e5a/b84536fc44919f417b5c4aafsfef2e0e/res/Obabal34

-c2ed-4474-86fe-49c59c6431f7/skitch.png

So the arguments that are objects are considered internal, because there __is involved...

Associated revisions

Revision 85ceb84e - 2013-02-26 11:30 - Bastian Waidelich
[BUGFIX] Routing includes object arguments even though it should not

Route::resolve() considered "__identity" arguments as internal and ignored them,

if they were not part of the respective Route defaults or uriPattern.

This change fixes this by only iterating through sub requests (marked with a "--

Change-Id: 163d3c302524{832224bf0fdc7a6255cb631d16¢8
Fixes: #45463
Releases: master, 2.0

Revision 890fda2e - 2013-03-20 16:24 - Bastian Waidelich

[BUGFIX] Routing includes object arguments even though it should not

Route::resolve() considered "__identity" arguments as internal and ignored them,

if they were not part of the respective Route defaults or uriPattern.

This change fixes this by only iterating through sub requests (marked with a "--")

Change-Id: 163d3c302524f832224bf0fdc7a6255¢ch631d16¢8
Fixes: #45463
Releases: master, 2.0

History

#1 - 2013-02-15 13:58 - Bastian Waidelich
- Status changed from New to Accepted

#2 - 2013-02-15 14:53 - Gerrit Code Review

- Status changed from Accepted to Under Review

Patch set 1 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/18302

#3 - 2013-02-25 14:42 - Gerrit Code Review

Patch set 2 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/18302

#4 - 2013-02-26 11:30 - Gerrit Code Review

Patch set 3 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/18302

#5 - 2013-03-20 16:25 - Gerrit Code Review

Patch set 1 for branch 2.0 has been pushed to the review server.
It is available at https://review.typo3.org/19092
#6 - 2013-03-20 16:37 - Bastian Waidelich
- Status changed from Under Review to Resolved
- % Done changed from 0 to 100

Applied in changeset commit:890fda2e46eb3c3eb7147¢3f985{847a65e03124.
